// IME Test.cpp : Defines the entry point for the application.
 //

#include "stdafx.h"
#include <dbghelp.h>
#include "CInput.h"


/*----------------------------------------------------------------------------*/ 
LONG __stdcall Exception_Minidump(_EXCEPTION_POINTERS* pExceptionInfo)
{
	char fileName[MAX_PATH];
	GetModuleFileName(NULL, fileName, sizeof(fileName));
	char* ext = strrchr(fileName, '.');
	strcpy(ext ? ext : fileName+strlen(fileName), ".dmp");

	MessageBox(NULL, fileName, fileName, MB_OK);

	HANDLE hProcess = GetCurrentProcess();
	DWORD dwProcessID = GetCurrentProcessId();
	HANDLE hFile = CreateFile(fileName, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	MINIDUMP_EXCEPTION_INFORMATION eInfo;
	eInfo.ThreadId = GetCurrentThreadId();
	eInfo.ExceptionPointers = pExceptionInfo;
	eInfo.ClientPointers = FALSE;

    MiniDumpWriteDump(hProcess, dwProcessID, hFile, MiniDumpNormal, pExceptionInfo ? &eInfo : NULL, NULL, NULL);

	return EXCEPTION_EXECUTE_HANDLER;
}

/*----------------------------------------------------------------------------*/ 
FILE* fException;

BOOL CALLBACK EnumerateLoadedModulesProc(PSTR ModuleName, ULONG ModuleBase, ULONG ModuleSize, PVOID UserContext)
{
	DWORD offset = *((DWORD*)UserContext);

	if (offset >= ModuleBase && offset <= ModuleBase + ModuleSize ) {
		fprintf(fException, "%s\t", ModuleName);
		return FALSE;
	} else {
		return TRUE;
	}
}

LONG __stdcall Exception_CallStack(_EXCEPTION_POINTERS* pExceptionInfo) {

	HANDLE		hProcess	= GetCurrentProcess();
	HANDLE		hThread		= GetCurrentThread();
	
	SymSetOptions(SYMOPT_DEFERRED_LOADS | SYMOPT_UNDNAME | SYMOPT_LOAD_LINES);

	if (fException = fopen("callstack.txt", "at")) {

		if (SymInitialize(hProcess, NULL, TRUE)) {

			fprintf(fException, "Exception Type:0x%08x\n", pExceptionInfo->ExceptionRecord->ExceptionCode);
			fprintf(fException, "\r\n");

			CONTEXT&	context		= *pExceptionInfo->ContextRecord;

			fprintf(fException, "eax: 0x%08x\tebx: 0x%08x\r\n", context.Eax, context.Ebx);
			fprintf(fException, "ecx: 0x%08x\tedx: 0x%08x\r\n", context.Ecx, context.Edx);
			fprintf(fException, "esi: 0x%08x\tedi: 0x%08x\r\n", context.Esi, context.Edi);
			fprintf(fException, "ebp: 0x%08x\tesp: 0x%08x\r\n", context.Ebp, context.Esp);
			fprintf(fException, "\r\n");

			STACKFRAME	stackFrame = {0, };
			stackFrame.AddrPC.Offset	= context.Eip;
			stackFrame.AddrPC.Mode		= AddrModeFlat;
			stackFrame.AddrStack.Offset	= context.Esp;
			stackFrame.AddrStack.Mode	= AddrModeFlat;
			stackFrame.AddrFrame.Offset	= context.Ebp;
			stackFrame.AddrFrame.Mode	= AddrModeFlat;

			for (int i=0; i < 512 && stackFrame.AddrPC.Offset; ++i) {

				//if (StackWalk(IMAGE_FILE_MACHINE_I386, hProcess, hThread, &stackFrame, &context, NULL, SymFunctionTableAccess, SymGetModuleBase, NULL) != FALSE) {
				if (StackWalk(IMAGE_FILE_MACHINE_I386, hProcess, hThread, &stackFrame, &context, NULL, NULL, NULL, NULL) != FALSE) {
					DWORD64				dwDisp64 = 0;
					char				chSymbol[256] = {0, };
					PSYMBOL_INFO		pSymbol = (PSYMBOL_INFO)chSymbol;

					pSymbol->SizeOfStruct	= sizeof(SYMBOL_INFO);
					pSymbol->MaxNameLen		= sizeof(chSymbol) - sizeof(PSYMBOL_INFO) + 1;

					if (SymFromAddr(hProcess, stackFrame.AddrPC.Offset, &dwDisp64, pSymbol))
					{
						DWORD	dwDisp = 0;
						IMAGEHLP_LINE64 errorLine = { sizeof(IMAGEHLP_LINE64), 0, };
						IMAGEHLP_LINE64 symbolLine = { sizeof(IMAGEHLP_LINE64), 0, };

						if (SymGetLineFromAddr64(hProcess, stackFrame.AddrPC.Offset, &dwDisp, &errorLine) && SymGetLineFromAddr64(hProcess, stackFrame.AddrPC.Offset-(DWORD)dwDisp64, &dwDisp, &symbolLine))
						{
							EnumerateLoadedModules(hProcess, EnumerateLoadedModulesProc, &stackFrame.AddrPC.Offset);
							fprintf(fException, "%s() + %d line [0x%04x]\n", pSymbol->Name, errorLine.LineNumber - symbolLine.LineNumber, dwDisp64);
							fprintf(fException, "\t\t\t\t%s, %d line\n", errorLine.FileName, errorLine.LineNumber);
						} else {
							EnumerateLoadedModules(hProcess, EnumerateLoadedModulesProc, &stackFrame.AddrPC.Offset);
							fprintf(fException, "%s() + offset : 0x%04x\n", pSymbol->Name, errorLine.LineNumber - symbolLine.LineNumber, dwDisp64);
							fprintf(fException, "\t\t\t\tNo Line Information\n");
						}
					}
					else
					{
						// SymFromAddr failed
						EnumerateLoadedModules(hProcess, EnumerateLoadedModulesProc, &stackFrame.AddrPC.Offset);
						fprintf(fException, "0x%08x\n", stackFrame.AddrPC.Offset);
						fprintf(fException, "\t\t\t\tSymFromAddr returned error : %d\n", GetLastError());
					}		
				} else { 
					break;
				}
			} 

			fprintf(fException, "\r\n");

			SymCleanup(hProcess);
		}

		fclose(fException);
		fException = NULL;
	}

	return	EXCEPTION_EXECUTE_HANDLER;
}
/*----------------------------------------------------------------------------*/ 
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
int					GetCodePageFromLang( LANGID langid );

CInput		g_input;

/*----------------------------------------------------------------------------*/ 
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	SetUnhandledExceptionFilter(Exception_Minidump);


	const char szWindowName[] = "IME Test";

	WNDCLASSEX wcex;

	wcex.cbSize			= sizeof(WNDCLASSEX); 
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, IDI_APPLICATION);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowName;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, IDI_APPLICATION);

	ATOM atom = RegisterClassEx(&wcex);

	g_input.InitInput();

	HWND hWnd = CreateWindow(szWindowName, szWindowName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, 400, 300, NULL, NULL, hInstance, NULL);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

/*----------------------------------------------------------------------------*/ 
void ShowInputText(HDC hdc, HWND hWnd)
{
	HFONT hFont = CreateFont(16, 0, 0, 0, 400, FALSE, FALSE, FALSE, g_input.GetCharSet(), OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "");

	if(hFont) {

		HFONT hFontOld = (HFONT)SelectObject(hdc, (HGDIOBJ)hFont);

		char text[256];
		int textLen;
		SIZE editTextSize;

		/* Draw Indicator */ 
		SetTextColor(hdc, 0x00000000);

		if(g_input.GetImeState() == 1) {
			SetBkColor(hdc, 0x007F7FFF);
		} else {
			SetBkColor(hdc, 0x00CCCCCC);
		}

		const wchar_t* indicator = g_input.GetIndicator();
		TextOutW(hdc, 0, 0, indicator, wcslen(indicator));
		
		/* Draw Edit Text */ 
		SetBkColor(hdc, 0x00FFFFFF);

		textLen = g_input.GetInput(text, sizeof(text));

		TextOutA(hdc, 20, 0, text, textLen);

		GetTextExtentPoint32A(hdc, text, textLen, &editTextSize);
		
		/* Draw Compostion Text */ 
		SetBkColor(hdc, 0x00CCCCCC);

		textLen = g_input.GetComp(text, sizeof(text));

		TextOutA(hdc, 20 + editTextSize.cx, 0, text, textLen);

		/* Draw Underline */ 
		int start, end;
		SIZE ulStart, ulEnd;

		g_input.GetUnderLine(&start, &end);
		GetTextExtentPoint32A(hdc, text, start, &ulStart);
		GetTextExtentPoint32A(hdc, text, end, &ulEnd);

		HPEN hPen = CreatePen(PS_DOT, 0, 0x000000FF);
		HPEN hOldPen = (HPEN)SelectObject(hdc, (HGDIOBJ)hPen);

		MoveToEx(hdc, 20 + editTextSize.cx+ulStart.cx, ulEnd.cy-1, NULL);
		LineTo(hdc, 20 + editTextSize.cx+ulEnd.cx, ulEnd.cy-1);

		SelectObject(hdc, (HGDIOBJ)hOldPen);

		int cx = 0;
		int cy = 20;
		/* Draw Reading */ 
		SetBkColor(hdc, 0x007FFF7F);

		textLen = g_input.GetReading(text, sizeof(text));
		if(!g_input.IsVerticalReading()) {
			TextOut(hdc, 0, cy, text, textLen);
		} else {
			char* begin = text;
			char* end = text + textLen;
			for(int i=0; i<4 && begin<end; ++i) {
				char* next = CharNextExA(g_input.GetCodePage(), begin, 0);

				TextOut(hdc, 0, cy, begin, next-begin);

				SIZE readSize;

				GetTextExtentPoint32(hdc, begin, next-begin, &readSize);

				cy += readSize.cy;

				begin = next;
			}
		}

		/* Draw Candidate */ 
		SetTextColor(hdc, 0x00000000);

		int count = min(g_input.GetCandidateCount(), g_input.GetCandidatePageStart()+g_input.GetCandidatePageSize());
		for(int i=g_input.GetCandidatePageStart(); i<count; ++i) {

			if(i == g_input.GetCandidateSelection()) {
				SetBkColor(hdc, 0x00FFCFCF);
			} else {
				SetBkColor(hdc, 0x00FF7F7F);
			}

			int textLen = g_input.GetCandidate(i, text, sizeof(text));

			TextOut(hdc, cx, cy, text, textLen);

			SIZE candSize;

			GetTextExtentPoint32(hdc, text, textLen, &candSize);

			if(!g_input.IsVerticalCandidate()) {
				cx += candSize.cx;
			} else {
				cy += candSize.cy;
			}
		}

		SelectObject(hdc, (HGDIOBJ)hFontOld);
	}
}

/*----------------------------------------------------------------------------*/ 
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_CREATE:
		g_input.OnInputLanguageChange(hWnd, 0, (LPARAM)GetKeyboardLayout(0));
		return 0L;

	/* IME Messages */ 
	case WM_INPUTLANGCHANGE:
		g_input.OnInputLanguageChange(hWnd, wParam, lParam);
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case WM_IME_SETCONTEXT:
		lParam = 0;
		break;

	case WM_IME_STARTCOMPOSITION:
		return 0L;

	case WM_IME_COMPOSITION:
		if(g_input.OnComposition(hWnd, wParam, lParam)) {
			InvalidateRect(hWnd, NULL, TRUE);
			return 0L;
		}
		break;

	case WM_IME_ENDCOMPOSITION:
		if(g_input.OnEndComposition(hWnd, wParam, lParam)) {
			InvalidateRect(hWnd, NULL, TRUE);
			return 0L;
		}
		break;

	case WM_IME_NOTIFY:
		if(g_input.OnNotify(hWnd, wParam, lParam)) {
			InvalidateRect(hWnd, NULL, TRUE);
			return 0L;
		}
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case WM_CHAR:
		g_input.OnChar(hWnd, wParam, lParam);
		InvalidateRect(hWnd, NULL, TRUE);
		break;
	/* End of IME Messages */ 

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		ShowInputText(hdc, hWnd);
		EndPaint(hWnd, &ps);
		return 0L;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0L;
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*----------------------------------------------------------------------------*/ 
